import java.util.Scanner;

public class Loki {

	// Constante usada para colocar ou tirar do padrao ASCII
	// O caractere A eh representado pelo numero 65
	// Voce sabia que um char, eh na verdade um numero inteiro? De uma pesquisada sobre isso!
	private final static int VALOR_ASCII_A = (int) 'A';
	
	public static char[] desafio (char[] vetor) {
		
		// Valores iniciais para o Fibonacci
		/*
		 * Comecar com ant=1 e pos=1 faz com que as somas funcionem corretamente
		 * e dentro do laco desde a primeira iteracao:
		 * primeiro sera 1 e o segundo termo tambem
		 */		
		int ant = 1;
		int pos = 0;
		
		// Roda para cada letra
		for (int i = 0; i < vetor.length; i++) {
				
			// Atualiza o valor do Fibonacci
			int atual = ant + pos;
			ant = pos;
			pos = atual;
			
			// Se for um numero, coloca um espaco
			// De uma olhada na funcao isDigit(), ela facilita bastante o trabalho
			// e nao precisamos fazer uma condicao para cada um dos 10 algarismos
			if (Character.isDigit(vetor[i])) {
				vetor[i] = ' ';
				continue;
			}
			
			// Acha o valor da letra codificada
			// Ou seja, A sera igual a 0, B igual a 1, etc...
			int valorLetraBruto = vetor[i] - VALOR_ASCII_A; // valor entre 0 a 26
			// Acha a distancia ate a letra real, de acordo com a sequencia de Fibonacci
			// e fazendo com que seja comapativel no alfabeto (mod de 26, pois sao 26 letras)
			int offset = (atual) % 26; // valor entre 0 a 26
			// Atualiza o valor, subtraindo a distancia
			int novoValor = (valorLetraBruto - offset) % 26; // valor entre 0 a 26
			// Se nao estivar na tabela ASCII, roda uma vez o alfabeto (+26) para entrar no padrao
			if (novoValor < 0) novoValor += 26;
			
			// Atualiza novo valor
			vetor[i] = (char) (novoValor + VALOR_ASCII_A); // novo valor
		}
		
		return vetor;
	}
	
	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		
		// Recebe o numero de casos
		int casos = sc.nextInt();
		// Usado para ler a quebra de linha logo depois do numero de casos
		sc.nextLine();
		
		// Roda os casos de teste
		for (int i = 0; i < casos; i++) {
			// Transforma a entrada em vetor de char
			char[] input = sc.nextLine().toCharArray();
			// Chama o metodo para resolver o desafio
			char[] output = desafio(input);
			
			// Imprime a resposta final
			for (char c : output) {
				System.out.print(c);
			} System.out.println();	 // Quebra de linha no final dos casos		
		}
	}
	
}
